Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.support.incrementer
Class SqlServerMaxValueIncrementer

    java.lang.Object
      org.springframework.jdbc.support.incrementer.AbstractDataFieldMaxValueIncrementer
          org.springframework.jdbc.support.incrementer.AbstractColumnMaxValueIncrementer
              org.springframework.jdbc.support.incrementer.SqlServerMaxValueIncrementer

All Implemented Interfaces:
  InitializingBean, DataFieldMaxValueIncrementer

    public class SqlServerMaxValueIncrementer

extends AbstractColumnMaxValueIncrementer

`DataFieldMaxValueIncrementer` that increments the maximum value of a given SQL Server table with the equivalent of an auto-increment column. Note: If you use this class, your Derby key column should NOT be defined as an IDENTITY column, as the sequence table does the job.

This class is inteded to be used with Microsoft SQL Server.

The sequence is kept in a table. There should be one sequence table per table that needs an auto-generated key.

Example:

     create table tab (id int not null primary key, text varchar(100))
     create table tab_sequence (id bigint identity)
     insert into tab_sequence default values

If "cacheSize" is set, the intermediate values are served without querying the database. If the server or your application is stopped or crashes or a transaction is rolled back, the unused values will never be served. The maximum hole size in numbering is consequently the value of cacheSize. HINT: Since Microsoft SQL Server supports the JDBC 3.0 `getGeneratedKeys` method, it is recommended to use IDENTITY columns directly in the tables and then using a `SimpleJdbcInsert` or utilizing a `KeyHolder` when calling the with the `update(PreparedStatementCreator psc, KeyHolder generatedKeyHolder)` method of the `JdbcTemplate`.

Thanks to Preben Nilsson for the suggestion!

Since:
  2.5.5
Author:
  Thomas Risberg

Field Summary

Fields inherited from class org.springframework.jdbc.support.incrementer.AbstractDataFieldMaxValueIncrementer
`paddingLength`

Constructor Summary
`SqlServerMaxValueIncrementer()` Default constructor for bean property style usage.
`SqlServerMaxValueIncrementer(javax.sql.DataSource dataSource, java.lang.String incrementerName, java.lang.String columnName)` Convenience constructor.

Method Summary
`protected long` | `getNextKey()` Determine the next key to use, as a long.

Methods inherited from class org.springframework.jdbc.support.incrementer.AbstractColumnMaxValueIncrementer
`afterPropertiesSet, getCacheSize, getColumnName, setCacheSize, setColumnName`

Methods inherited from class org.springframework.jdbc.support.incrementer.AbstractDataFieldMaxValueIncrementer
`getDataSource, getIncrementerName, getPaddingLength, nextIntValue, nextLongValue, nextStringValue, setDataSource, setIncrementerName, setPaddingLength`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SqlServerMaxValueIncrementer

    public SqlServerMaxValueIncrementer()

  Default constructor for bean property style usage.

  See Also:
    `AbstractDataFieldMaxValueIncrementer.setDataSource(javax.sql.DataSource)`, `AbstractDataFieldMaxValueIncrementer.setIncrementerName(java.lang.String)`, `AbstractColumnMaxValueIncrementer.setColumnName(java.lang.String)`

### SqlServerMaxValueIncrementer

    public SqlServerMaxValueIncrementer(javax.sql.DataSource dataSource,
                                        java.lang.String incrementerName,
                                        java.lang.String columnName)

  Convenience constructor.

  Parameters:
    `dataSource` - the DataSource to use
    `incrementerName` - the name of the sequence/table to use
    `columnName` - the name of the column in the sequence table to use

Method Detail

### getNextKey

    protected long getNextKey()
                       throws DataAccessException

  Description copied from class: `AbstractDataFieldMaxValueIncrementer`
  Determine the next key to use, as a long.

  Specified by:
    `getNextKey` in class `AbstractDataFieldMaxValueIncrementer`
  Returns:
    the key to use as a long. It will eventually be converted later in another format by the public concrete methods of this class.
  Throws:
    `DataAccessException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD